package cn.com.qmth.mps.util;

import java.util.Date;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import cn.com.qmth.mps.bean.User;
import cn.com.qmth.mps.config.SysProperty;
import cn.com.qmth.mps.support.SpringContextHolder;

public class ActiveDataUtil {

	private static SysProperty sysProperty = SpringContextHolder.getBean(SysProperty.class);

	private static int online_user_count = 0;

	private final static Long DEFTIMEOUT = (sysProperty.getSessionTimeout() == null ? 7200
			: sysProperty.getSessionTimeout()) * 1000L;

	private final static Map<Long, User> userActiveData = new ConcurrentHashMap<>();

	public static void updateUserActive(User user) {
		user.setActiveTime(System.currentTimeMillis());
		userActiveData.put(user.getId(), user);
	}

	private static void clearTimeOutUserActive() {
		Date d = new Date();
		Long now = d.getTime();
		for (Long k : userActiveData.keySet()) {
			if (now - userActiveData.get(k).getActiveTime() > DEFTIMEOUT) {
				userActiveData.remove(k);
			}
		}
	}

	public static void updateUserCount() {
		clearTimeOutUserActive();
		online_user_count = userActiveData.size();
	}

	public static int getUserCount() {
		return online_user_count;
	}

	public static void userLogout(Long userId) {
		userActiveData.remove(userId);
		updateUserCount();
	}

	public static synchronized void userLogin(User user) {
		updateUserActive(user);
		updateUserCount();

	}

	public static User getUser(Long userId) {
		return userActiveData.get(userId);
	}

}
